type 'a t = {
  listeners : ('a -> unit) Queue.t;
}

let create () =
  let listeners = Queue.create () in
  let t = { listeners } in
  t, fun v -> Queue.iter (fun listener -> listener v) listeners

let fold func init events =
  let state = ref init in
  let t, send = create () in
  Queue.push (fun v -> state := func !state v; send !state) events.listeners;
  t

let map func events =
  let t, send = create () in
  Queue.push (fun v -> send (func v)) events.listeners;
  t
